# CfnVirtualNode

Creates a virtual node within a service mesh.

A virtual node acts as a logical pointer to a particular task group, such as an Amazon ECS service or a Kubernetes deployment. When you create a virtual node, you can specify the service discovery information for your task group, and whether the proxy running in a task group will communicate with other proxies using Transport Layer Security (TLS).

You define a `listener` for any inbound traffic that your virtual node expects. Any virtual service that your virtual node expects to communicate to is specified as a `backend` .

The response metadata for your new virtual node contains the `arn` that is associated with the virtual node. Set this value to the full ARN; for example, `arn:aws:appmesh:us-west-2:123456789012:myMesh/default/virtualNode/myApp` ) as the `APPMESH_RESOURCE_ARN` environment variable for your task group's Envoy proxy container in your task definition or pod spec. This is then mapped to the `node.id` and `node.cluster` Envoy parameters.

> By default, App Mesh uses the name of the resource you specified in `APPMESH_RESOURCE_ARN` when Envoy is referring to itself in metrics and traces. You can override this behavior by setting the `APPMESH_RESOURCE_CLUSTER` environment variable with your own name.

For more information about virtual nodes, see [Virtual nodes](https://docs.aws.amazon.com/app-mesh/latest/userguide/virtual_nodes.html) . You must be using `1.15.0` or later of the Envoy image when setting these variables. For more information aboutApp Mesh Envoy variables, see [Envoy image](https://docs.aws.amazon.com/app-mesh/latest/userguide/envoy.html) in the AWS App Mesh User Guide.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnVirtualNode
Implements: IInspectable, ITaggable, IEnvironmentAware, IVirtualNodeRef, IConstruct, IDependable

- CloudFormation: [`AWS::AppMesh::VirtualNode`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-appmesh-virtualnode.html)
- Source: Generated code
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_appmesh as appmesh } from 'aws-cdk-lib';
const cfnVirtualNode = new appmesh.CfnVirtualNode(this, 'MyCfnVirtualNode', {
  meshName: 'meshName',
  spec: {
    backendDefaults: {
      clientPolicy: {
        tls: {
          validation: {
            trust: {
              acm: {
                certificateAuthorityArns: ['certificateAuthorityArns'],
              },
              file: {
                certificateChain: 'certificateChain',
              },
              sds: {
                secretName: 'secretName',
              },
            },

            // the properties below are optional
            subjectAlternativeNames: {
              match: {
                exact: ['exact'],
              },
            },
          },

          // the properties below are optional
          certificate: {
            file: {
              certificateChain: 'certificateChain',
              privateKey: 'privateKey',
            },
            sds: {
              secretName: 'secretName',
            },
          },
          enforce: false,
          ports: [123],
        },
      },
    },
    backends: [{
      virtualService: {
        virtualServiceName: 'virtualServiceName',

        // the properties below are optional
        clientPolicy: {
          tls: {
            validation: {
              trust: {
                acm: {
                  certificateAuthorityArns: ['certificateAuthorityArns'],
                },
                file: {
                  certificateChain: 'certificateChain',
                },
                sds: {
                  secretName: 'secretName',
                },
              },

              // the properties below are optional
              subjectAlternativeNames: {
                match: {
                  exact: ['exact'],
                },
              },
            },

            // the properties below are optional
            certificate: {
              file: {
                certificateChain: 'certificateChain',
                privateKey: 'privateKey',
              },
              sds: {
                secretName: 'secretName',
              },
            },
            enforce: false,
            ports: [123],
          },
        },
      },
    }],
    listeners: [{
      portMapping: {
        port: 123,
        protocol: 'protocol',
      },

      // the properties below are optional
      connectionPool: {
        grpc: {
          maxRequests: 123,
        },
        http: {
          maxConnections: 123,

          // the properties below are optional
          maxPendingRequests: 123,
        },
        http2: {
          maxRequests: 123,
        },
        tcp: {
          maxConnections: 123,
        },
      },
      healthCheck: {
        healthyThreshold: 123,
        intervalMillis: 123,
        protocol: 'protocol',
        timeoutMillis: 123,
        unhealthyThreshold: 123,

        // the properties below are optional
        path: 'path',
        port: 123,
      },
      outlierDetection: {
        baseEjectionDuration: {
          unit: 'unit',
          value: 123,
        },
        interval: {
          unit: 'unit',
          value: 123,
        },
        maxEjectionPercent: 123,
        maxServerErrors: 123,
      },
      timeout: {
        grpc: {
          idle: {
            unit: 'unit',
            value: 123,
          },
          perRequest: {
            unit: 'unit',
            value: 123,
          },
        },
        http: {
          idle: {
            unit: 'unit',
            value: 123,
          },
          perRequest: {
            unit: 'unit',
            value: 123,
          },
        },
        http2: {
          idle: {
            unit: 'unit',
            value: 123,
          },
          perRequest: {
            unit: 'unit',
            value: 123,
          },
        },
        tcp: {
          idle: {
            unit: 'unit',
            value: 123,
          },
        },
      },
      tls: {
        certificate: {
          acm: {
            certificateArn: 'certificateArn',
          },
          file: {
            certificateChain: 'certificateChain',
            privateKey: 'privateKey',
          },
          sds: {
            secretName: 'secretName',
          },
        },
        mode: 'mode',

        // the properties below are optional
        validation: {
          trust: {
            file: {
              certificateChain: 'certificateChain',
            },
            sds: {
              secretName: 'secretName',
            },
          },

          // the properties below are optional
          subjectAlternativeNames: {
            match: {
              exact: ['exact'],
            },
          },
        },
      },
    }],
    logging: {
      accessLog: {
        file: {
          path: 'path',

          // the properties below are optional
          format: {
            json: [{
              key: 'key',
              value: 'value',
            }],
            text: 'text',
          },
        },
      },
    },
    serviceDiscovery: {
      awsCloudMap: {
        namespaceName: 'namespaceName',
        serviceName: 'serviceName',

        // the properties below are optional
        attributes: [{
          key: 'key',
          value: 'value',
        }],
        ipPreference: 'ipPreference',
      },
      dns: {
        hostname: 'hostname',

        // the properties below are optional
        ipPreference: 'ipPreference',
        responseType: 'responseType',
      },
    },
  },

  // the properties below are optional
  meshOwner: 'meshOwner',
  tags: [{
    key: 'key',
    value: 'value',
  }],
  virtualNodeName: 'virtualNodeName',
});
```

## Initializer

```ts
new CfnVirtualNode(scope: Construct, id: string, props: CfnVirtualNodeProps)
```

## Construct Props

- `meshName`: string (required) — The name of the service mesh to create the virtual node in.

- `meshOwner`: string — The AWS IAM account ID of the service mesh owner.

  If the account ID is not your own, then the account that you specify must share the mesh with your account before you can create the resource in the service mesh. For more information about mesh sharing, see [Working with shared meshes](https://docs.aws.amazon.com/app-mesh/latest/userguide/sharing.html) .

- `spec`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnVirtualNode.VirtualNodeSpecProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_appmesh.CfnVirtualNode.VirtualNodeSpecProperty.html) (required) — The virtual node specification to apply.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — Optional metadata that you can apply to the virtual node to assist with categorization and organization.

  Each tag consists of a key and an optional value, both of which you define. Tag keys can have a maximum character length of 128 characters, and tag values can have a maximum length of 256 characters.

- `virtualNodeName`: string — The name to use for the virtual node.

## Properties

- `attrArn`: string — The full Amazon Resource Name (ARN) for the virtual node.

- `attrId`: string

- `attrMeshName`: string — The name of the service mesh that the virtual node resides in.

- `attrMeshOwner`: string — The AWS IAM account ID of the service mesh owner.

  If the account ID is not your own, then it's the ID of the account that shared the mesh with your account. For more information about mesh sharing, see [Working with Shared Meshes](https://docs.aws.amazon.com/app-mesh/latest/userguide/sharing.html) .

- `attrResourceOwner`: string — The AWS IAM account ID of the resource owner.

  If the account ID is not your own, then it's the ID of the mesh owner or of another account that the mesh is shared with. For more information about mesh sharing, see [Working with Shared Meshes](https://docs.aws.amazon.com/app-mesh/latest/userguide/sharing.html) .

- `attrUid`: string — The unique identifier for the virtual node.

- `attrVirtualNodeName`: string — The name of the virtual node.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `creationStack`: string[]

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `meshName`: string — The name of the service mesh to create the virtual node in.

- `meshOwner`: string — The AWS IAM account ID of the service mesh owner.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `spec`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnVirtualNode.VirtualNodeSpecProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_appmesh.CfnVirtualNode.VirtualNodeSpecProperty.html) — The virtual node specification to apply.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `tags`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — Optional metadata that you can apply to the virtual node to assist with categorization and organization.

- `virtualNodeName`: string — The name to use for the virtual node.

- `virtualNodeRef`: [VirtualNodeReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_appmesh.VirtualNodeReference.html) — A reference to a VirtualNode resource.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForVirtualNode(resource: IVirtualNodeRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isCfnVirtualNode(x: any): boolean` (static) — Checks whether the given object is a CfnVirtualNode.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
